#include<stdio.h>
#include "cquad.h"

double fun(double x);

int main()
{
    double a, b, epsabs, epsrel, result, abserr;
    int neval, ier;

 // a and b are the integration limits
    a = 0.0;
    b = 1.0;

 // epsabs and epsrel determine the accuracy requirement
    epsabs = 0;
    epsrel = 0.001;

    result = cquad_dqng(fun, a, b, epsabs, epsrel, &abserr, &neval, &ier);	

 // print the result
    printf("\nFunction:  sqrt(x) * log(x)  over [0, 1]\n");
    printf("\nIntegral approximation:           %lg\n", result);
    printf("Estimate of absolute error:        %lg\n", abserr);
    printf("Number of function evaluations:    %d\n", neval);
    printf("Error code:  %d\n\n", ier);
}
